<?php
/*
MeltingIce File System copyright Ryan LeFevre.
Feel free to modify this script, but please leave this comment here.

namecheck.php: Security functions that check uploaded file names and usernames to prevent security holes.
*/
	function isValid($varx, $file=false)
	{
		if(!$file)
		{
			if(ereg("([^a-zA-Z0-9])",$varx)) //makes sure usernames consist of only letters and/or numbers
			{
				$valid=false;
			}
			else
			{
				$valid=true;
			}
		}
		else
		{
			if(preg_match('/#|\*|<|>|\$|\||:|\"|\//',$varx)) //makes sure files and folders don't have these characters in them
			{
				$valid=false;
			}
			else
			{
				$valid=true;
			}
		}

		return $valid;
	}
	
	function filetypeCheck($name)
	{
		$allowed = true;
		$boom = explode(".",$name);
		
		
		if(ereg("(php+)",$boom[count($boom)-1])) //disallows upload of PHP files for security purposes
		{
			$allowed = false;
		}
		
		return $allowed;
	}
	
	function dirCheck($urlreq)
	{
		$allowed = true;
		
		$test = explode("/",$urlreq);
		if(array_search("..",$test))
		{
			$allowed = false;
		}
		return $allowed;
	}
	
	function uploadCheck($url)
	{
		$allowed = true;
		if(isset($_SESSION['frienddir']))
		{
			if($_SESSION['perms'] == "rw")
			{
				if(! is_dir("users/".$_SESSION['frienddir'].$url))
				{
					$allowed = false;
				}	
			}
			else
			{
				$allowed = false;
			}
		}
		else
		{
			if(! is_dir("users/".$_SESSION['username'].$url))
			{
				$allowed = false;
			}
		}
		
		if(! dirCheck($url))
		{
			$allowed = false;
		}
		
		return $allowed;
	}
?>